#include "foablak.h"
#include <qlayout.h>
#include <qmessagebox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qfile.h>
#include <qtextstream.h>
#include "listboxsocket.h"


#define START_X 450
#define START_Y 350
#define SPACE 80

FoAblak::FoAblak(QWidget* parent, const char* name, WFlags fl)
: foablakBase(parent,name,fl)
{
    c=new QCanvas(this);
    c->resize(500,400);
    cv=new QCanvasView(c, this);
    cv->setGeometry( QRect( 10, 50, 500, 410 ) );
/*    QBoxLayout * l = new QVBoxLayout( this );
    l->addWidget( (QWidget*) lineEdit1 );
    l->addWidget( cv );*/
    cv->setVScrollBarMode(QScrollView::AlwaysOff);
    cv->setHScrollBarMode(QScrollView::AlwaysOff);
    c->setBackgroundColor(QColor(200,200,200));
    //feldolgoz(QString("{{00x{0x0{0x00}}}000}"), 0, 0);
    new ListBoxSocket(listBox1, 1111, this);
}

int FoAblak::feldolgoz(QString mit, int x, int y) {
    int poz=0;
    
    if (mit[poz]=='{') {
	pontotrajzol(x, y);
	poz++;
	for (int dir=0;dir<4;dir++) {
	    int festes=(mit[poz++].latin1())-97;
	    if (mit[poz]=='u'){
		vonalrajzol(x, y, dir, false, festes);
		poz++;
	    } else if (mit[poz]=='x') {
		vonalrajzol(x, y, dir, festes);
		poz++;
	    } else if (mit[poz]=='0') {
		poz++;
	    } else if (mit[poz]=='{') {
		vonalrajzol(x, y, dir, festes);
		switch (dir) {
		    case 0: poz+=feldolgoz(mit.mid(poz), x, y+1); break;
		    case 1: poz+=feldolgoz(mit.mid(poz), x-1, y); break;
		    case 2: poz+=feldolgoz(mit.mid(poz), x, y-1); break;
		    case 3: poz+=feldolgoz(mit.mid(poz), x+1, y); break;
		}
	    }
	}
	if (mit[poz]!='}') {
	    QMessageBox::information(this, "feldolgoz", "recursion error1");
	}
	return ++poz;
    } else {
	QMessageBox::information(this, "feldolgoz", "recursion error2");
	return 0;
    }
}

void FoAblak::pontotrajzol(int x, int y) {
    QCanvasRectangle* pont = new QCanvasRectangle(START_X-SPACE*x-5, START_Y-SPACE*y-5, 10, 10, c);
    pont->show();
}

void FoAblak::vonalrajzol(int x, int y, int dir, int festes, bool teljesen) {
    QCanvasLine* cl = new QCanvasLine(c);
    int space;
    if (teljesen)
	space=SPACE;
    else
	space=SPACE/2;
    switch(dir) {
	case 0: cl->setPoints(START_X-SPACE*x,START_Y-SPACE*y, START_X-SPACE*x,START_Y-SPACE*y-space);break;
	case 1: cl->setPoints(START_X-SPACE*x,START_Y-SPACE*y, START_X-SPACE*x+space,START_Y-SPACE*y);break;
	case 2: cl->setPoints(START_X-SPACE*x,START_Y-SPACE*y, START_X-SPACE*x,START_Y-SPACE*y+space);break;
	case 3: cl->setPoints(START_X-SPACE*x,START_Y-SPACE*y, START_X-SPACE*x-space,START_Y-SPACE*y);break;
    }
    switch (festes) {
	case 0:
		cl->setPen(QPen(QColor(0,0,0),1));
		break;
	case 1:
		cl->setPen(QPen(QColor(0,255,0),1));
		break;
	case 2:
		cl->setPen(QPen(QColor(255,0,0),1));
	        break;
	default:
		cl->setPen(QPen(QColor(0,0,255),4));
		break;
    }
    cl->show();
}

FoAblak::~FoAblak()
{
}

/*$SPECIALIZATION$*/




/*!
    \fn FoAblak::feldolgoz_str(QString mit)
 */
void FoAblak::feldolgoz_button()
{
    textLabel1->setText(lineEdit1->text());
    //lineEdit1->setEnabled(false);
    QCanvasItemList list = c->allItems();
    QCanvasItemList::Iterator it = list.begin();
    for (; it != list.end(); ++it) {
        if ( *it )
            delete *it;
    }
    feldolgoz(lineEdit1->text(), 0, 0);
    c->update();
    lineEdit1->setText("");
}

void FoAblak::feldolgoz_listbox()
{
    textLabel1->setText(listBox1->currentText());
    QCanvasItemList list = c->allItems();
    QCanvasItemList::Iterator it = list.begin();
    for (; it != list.end(); ++it) {
        if ( *it )
            delete *it;
    }
    feldolgoz(listBox1->currentText(), 0, 0);
    c->update();
}
